// rtl.h
#ifndef _RTL_
#define _RTL_

// ANSI and UNICODE strings handling
__inline char* __fastcall strcatA(char *dest, const char *src);
__inline wchar_t* __fastcall strcatW(wchar_t *dest, const wchar_t *src);
int __fastcall strcmpA(const char *s1, const char *s2);
int __fastcall strcmpW(const wchar_t *s1, const wchar_t *s2);
int __fastcall strcmpnA(const char *s1, const char *s2, unsigned long n);
int __fastcall strcmpnW(const wchar_t *s1, const wchar_t *s2, unsigned long n);
char* __fastcall strcpyA(char *dest, const char *src);
wchar_t* __fastcall strcpyW(wchar_t *dest, const wchar_t *src);
char* __fastcall strcpynA(char *dest, const char *src, unsigned long len);
wchar_t* __fastcall strcpynW(wchar_t *dest, const wchar_t *src, unsigned long len);
int __fastcall strcmpinA(const char *s1, const char *s2, unsigned long n);
int __fastcall strcmpinW(const wchar_t *s1, const wchar_t *s2, unsigned long n);
int __fastcall strcmpiW(const wchar_t *s1, const wchar_t *s2);
int __fastcall strcmpiA(const char *s1, const char *s2);
char* __fastcall strendA(const char *s);
wchar_t* __fastcall strendW(const wchar_t *s);
unsigned long __fastcall strlenA(const char *s);
unsigned long __fastcall strlenW(const wchar_t *s);

char __fastcall upcaseA(char c);
wchar_t __fastcall upcaseW(wchar_t c);
char __fastcall locaseA(char c);
wchar_t __fastcall locaseW(wchar_t c);

// Memory functions
int __fastcall memcmp(const void *p1, const void *p2, unsigned long length);
void __fastcall memcopy(void *dest, void *src, unsigned long length);
void __fastcall memzero(void *p1, unsigned long length);
//void __fastcall memfill(void *p1, unsigned long length, unsigned char fill);

// Conversion functions
char* __stdcall itoa(signed long int x, char *buf);
int __stdcall _atoi(char *s);

unsigned long __stdcall GetCmdLineParamA(unsigned long n, char *buf);
unsigned long __stdcall GetCmdLineParamW(unsigned long n, wchar_t *buf);

#endif /* _RTL_ */